#ifndef LDFCN_H
#define LDFCN_H

/*
 *	@(#)ldfcn.h	6.8	91/08/15	ACE
 *
 * ACE-COFF Utilities.
 *
 * This source file is part of the ACE Compiler Family.
 * Copyright reserved. This source file, or parts of it, may not
 * be reproduced or transmitted in any form, including reprinting,
 * photocopying or microfilming, or by any means, electronic,
 * mechanical or otherwise, or stored in a retrieval system,
 * or used for any purpose, without the prior written permission
 * of ACE Associated Computer Experts bv.
 * This source file is derived from UNIX System 5.0 (Copyright AT&T)
 *
 * (c) 1985 ACE Associated Computer Experts bv, Amsterdam
 *
 */

extern long	ftell();
extern char	*fgets();

#ifndef LDFILE
struct	ldfile {
	int	_fnum_;		/* so each instance of an LDFILE is unique */
	FILE	*ioptr;		/* system I/O pointer value */
	long	offset;		/* absolute offset to the start of the file */
	FILHDR	header;		/* the file header of the opened file */
	unsigned short	type;	/* indicator of the type of the file */
#ifdef ACE_COFF
	long	ssize;		/* the size of the string pool */
	unsigned long	scndx;	/* index of current supercoff member */
#endif
};


/*
	provide a structure "type" definition, and the associated
	"attributes"
*/

#define	LDFILE		struct ldfile
#define IOPTR(x)	x->ioptr
#define OFFSET(x)	x->offset
#define TYPE(x)		x->type
# ifdef ACE_COFF
#define SSIZE(x)	x->ssize
# endif /* ACE_COFF */
#define	HEADER(x)	x->header
#define LDFSZ		sizeof(LDFILE)

#ifdef PORTAR
# define PORTARCH
#else
# ifdef PORT5AR
#  define PORTARCH
# endif
#endif

/*
 *	Define various values of TYPE(ldptr).
 */
#define LDTYPE	0
#define TVTYPE	1
#define ARTYPE	2
#define SCTYPE	3

/*
	define symbolic positioning information for FSEEK (and fseek)
*/

#define BEGINNING	0
#define CURRENT		1
#define END		2

/*
	define a structure "type" for an archive header
*/

#ifdef PORTARCH
typedef struct
{
	char ar_name[16];
	long ar_date;
	int ar_uid;
	int ar_gid;
	long ar_mode;
	long ar_size;
} archdr;

#define	ARCHDR	archdr
#else
#define	ARCHDR	struct ar_hdr
#endif
#define ARCHSZ	sizeof(ARCHDR)


/*
	define some useful symbolic constants
*/

#define SYMTBL	0	/* section nnumber and/or section name of the Symbol Table */

#define	SUCCESS	 1
#define	CLOSED	 1
#define	FAILURE	 0
#define	NOCLOSE	 0
#define	BADINDEX	-1L

#define	OKFSEEK	0
#define	ERRFSEEK -1

/*
 *	In BSD, fseek returns -1 on failure, in SV, 0 on success
 *	(undocumented berkleleyism: it returns offset on succes)
 */
#ifdef	BSD
#define	checked_fseek(file,offset,whence) \
	(fseek (file, offset, whence) != ERRFSEEK ? OKFSEEK : ERRFSEEK)
#else
#define	checked_fseek(file,offset,whence) \
	(fseek (file, offset, whence))
#endif

/*
	define macros to permit the direct use of LDFILE pointers with the
	standard I/O library procedures
*/

LDFILE *ldopen();
LDFILE *ldaopen();

#define GETC(ldptr)	getc(IOPTR(ldptr))
#define GETW(ldptr)	getw(IOPTR(ldptr))
#define FEOF(ldptr)	feof(IOPTR(ldptr))
#define FERROR(ldptr)	ferror(IOPTR(ldptr))
#define FGETC(ldptr)	fgetc(IOPTR(ldptr))
#define FGETS(s,n,ldptr)	fgets(s,n,IOPTR(ldptr))
#define FILENO(ldptr)	fileno(IOPTR(ldptr))
#define FREAD(p,s,n,ldptr)	fread(p,s,n,IOPTR(ldptr))
#define FSEEK(ldptr,o,p)	checked_fseek(IOPTR(ldptr),(p==BEGINNING)?(OFFSET(ldptr)+o):o,p)
#define FTELL(ldptr)	(ftell(IOPTR(ldptr)) - OFFSET(ldptr))
#define FWRITE(p,s,n,ldptr)       fwrite(p,s,n,IOPTR(ldptr))
#define REWIND(ldptr)	rewind(IOPTR(ldptr))
#define SETBUF(ldptr,b)	setbuf(IOPTR(ldptr),b)
#define UNGETC(c,ldptr)		ungetc(c,IOPTR(ldptr))
#define STROFFSET(ldptr)	(HEADER(ldptr).f_symptr + HEADER(ldptr).f_nsyms * 18) /* 18 == SYMESZ */
#endif
#endif
