
#define UN_START_VCP                    0
#define START_VCP                       2
#define ACTIVATE_VIRTUAL_OR_EVENT_CHANNEL       1


#define H1_VCP_LINK_HEADER_UPPER_LIMIT_ADDRESS	0x0806
#define H1_VCP_LINK_HEADER_LOWER_LIMIT_ADDRESS	0x0807
#define H1_VCP_LINK_HEADER_OFFSET_ADDRESS	0x0808
#define H1_VCP_LINK_MODE_ADDRESS	0x0805

typedef struct {
	unsigned char LinkNumber;
	unsigned char HeaderLen;
	unsigned short HeaderOffset;
	unsigned long HeaderVal;
}VCP_INFO;

ConfigureUserVcp( int NumVirtualChannels, VCP_INFO *VcpInfo[], unsigned long FromParent )
{
	unsigned char HeaderVal[3];
	int i; 
	unsigned long Chan, BufAddr;
	unsigned long Register;

	SwitchVcpState(UN_START_VCP);
	Register = (NumVirtualChannels * 8 )+FromParent;
	SetMemStart(Register);
	SetMinInvalidChannelRegister(Register);
	Register = NumVirtualChannels * 32 + FromParent;
	Chan = FromParent;
	for( i = 0, BufAddr = Register; i < NumVirtualChannels; i++, BufAddr += 32 ){
		InitializeVLCBAndBufferPointer( Chan, BufAddr );
		SetHeaderInVLCB( Chan, VcpInfo[i]->LinkNumber, VcpInfo[i]->HeaderOffset );
		WriteHeaderInVLCB( Chan, VcpInfo[i]->HeaderLen, &(VcpInfo[i]->HeaderVal));
		SetChannelMode( Chan, ACTIVATE_VIRTUAL_OR_EVENT_CHANNEL );
		SetChannelMode( Chan+4, ACTIVATE_VIRTUAL_OR_EVENT_CHANNEL );
	}
	for ( i = 0; i < 4; i++ )
		UpdateHeaderForLink( 0x0, 0x0, 0x0, 0xffff, 
			H1_VCP_LINK_MODE_ADDRESS+i,
			H1_VCP_LINK_HEADER_OFFSET_ADDRESS+i,
			H1_VCP_LINK_HEADER_LOWER_LIMIT_ADDRESS+i,
			H1_VCP_LINK_HEADER_UPPER_LIMIT_ADDRESS+i);
	SetExternalRCBaseAddress( BufAddr );
	Register = BufAddr + NumVirtualChannels * 8 + 16;
	SetMemStart( Register );
	SetHeaderBaseAreaReg( Register );
	SwitchVcpState(START_VCP);
}

